/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description 		   : ϵͳ˯ģʽʾGPIOA_5ΪԴ4˯ߵȼ
 *******************************************************************************/

/* 
 ע⣺лHSEʱԴȴȶʱѡþйأѡһµľĶṩľ弰
 صݲֵͨR8_XT32M_TUNEĴòͬĸصݺƫõȶʱ䡣
 */

#include "CH57x_common.h"

#define PM_LOWPOWER_IDLE (0)
#define PM_LOWPOWER_HALT (0)
#define PM_LOWPOWER_SLEEP (1)
#define PM_LOWPOWER_SHUTDOWN (0)

#define  PM_RTC_WAKE (1)

void DebugInit( void )
{
  GPIOA_SetBits( GPIO_Pin_9 );
  GPIOA_ModeCfg( GPIO_Pin_9, GPIO_ModeOut_PP_5mA );
  UART1_DefInit();
}

int main()
{
  SetSysClock( CLK_SOURCE_PLL_60MHz );

  GPIOA_ModeCfg( GPIO_Pin_All, GPIO_ModeIN_PU );
  GPIOB_ModeCfg( GPIO_Pin_All, GPIO_ModeIN_PU );

  /* ôڵ */
  DebugInit();
  PRINT( "Start @ChipID=%02x\n", R8_CHIP_ID );
  PRINT( "Time=%s-%s\n",__TIME__,__DATE__ );
  DelayMs( 200 );

#if PM_IO_WAKE
  /* ûԴΪ GPIO - PA5 */
  GPIOA_ModeCfg( GPIO_Pin_5, GPIO_ModeIN_PU );
  GPIOA_ITModeCfg( GPIO_Pin_5, GPIO_ITMode_FallEdge );        // ½ػ
  PFIC_EnableIRQ( GPIO_A_IRQn );
  PWR_PeriphWakeUpCfg( ENABLE, RB_SLP_GPIO_WAKE, Edge_LongDelay );
#endif
#if PM_RTC_WAKE
  LClk32K_Select(Clk32K_LSE);//ⲿ32K
  R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;
  R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;
  R8_CK32K_CONFIG |= RB_CLK_XT32K_PON;
  R8_SAFE_ACCESS_SIG = 0;

  RTC_InitTime(2021,9,8,15,25,0);
  RTC_TMRFunCfg(Period_1_S);
  PFIC_EnableIRQ(RTC_IRQn);
       //PWR_UnitModCfg(DISABLE,0x1);
  PWR_PeriphWakeUpCfg( ENABLE, RB_SLP_RTC_WAKE, Edge_LongDelay );
  printf("Init RTC OK\r\n");
#endif
#if PM_LOWPOWER_IDLE
  PRINT( "IDLE mode sleep \n" );
  DelayMs( 1 );
  LowPower_Idle();
  PRINT( "wake.. \n" );
  DelayMs( 500 );
#endif    

#if PM_LOWPOWER_HALT
  PRINT( "Halt mode sleep \n" );
  DelayMs( 2 );
  LowPower_Halt();
  HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
  DelayMs( 2 );
  PRINT( "wake.. \n" );
  DelayMs( 500 );
#endif    

#if PM_LOWPOWER_SLEEP
  PRINT( "sleep mode sleep \n" );
  DelayMs( 2 );
  LowPower_Sleep( RB_PWR_RAM16K | RB_PWR_RAM2K | RB_PWR_EXTEND );       //ֻ14+2K SRAM 
  HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
  DelayMs( 5 );
  PRINT( "wake.. \n" );
  DelayMs( 500 );
#endif

#if PM_LOWPOWER_SHUTDOWN
  PRINT( "shut down mode sleep \n" );
  PWR_PeriphWakeUpCfg( ENABLE, RB_SLP_GPIO_WAKE, Edge_ShortDelay );
  DelayMs( 2 );
  LowPower_Shutdown( 0 );                          //ȫϵ磬Ѻλ
  /*
   ģʽѺִиλ벻У
   עҪȷϵͳ˯ȥٻѲǻѸλпܱIDLEȼ
   */
  HSECFG_Current( HSE_RCur_100 );     // Ϊ(͹ĺHSEƫõ)
  PRINT( "wake.. \n" );
  DelayMs( 500 );
#endif

  while( 1 )
    ;
}

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void GPIOA_IRQHandler( void )
{
  GPIOA_ClearITFlagBit( GPIO_Pin_6|GPIO_Pin_5 );
}

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void RTC_IRQHandler(void)
{
  UINT16 py; UINT16 pmon; UINT16 pd; UINT16 ph; UINT16 pm; UINT16 ps;
  RTC_GetTime(&py,&pmon,&pd,&ph,&pm,&ps);
    if (RTC_GetITFlag(RTC_TMR_EVENT)) {
        printf("%d%d%d%dʱ%d%d\r\n",py,pmon,pd,ph,pm,ps);
        RTC_ClearITFlag(RTC_TMR_EVENT);
    }
}
